SystemOrganization addCategory: #'Spec-Core'!

!Dictionary methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 2/9/2012 16:42'!
asValueHolder

	^ DictionaryValueHolder contents: self! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 2/9/2012 16:09'!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 1/19/2012 18:04'!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 2/9/2012 16:14'!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 2/9/2012 16:09'!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:34'!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:26'!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:27'!
oldContents: anObject
	
	oldContents := anObject! !

!Morph methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 1/18/2012 01:57'!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph focusOrder owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:57'!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/17/2012 03:20'!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:07'!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:08'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/1/2012 18:24'!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: 'BenjaminVanRyseghem 2/15/2012 18:22'!
beginsWith: aString fromList: aMorph

	^ false! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWithSpec

	^ self buildWithSpec: #internSpec! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:25'!
buildWithSpec: aSpec

	^ SpecInterpreter buildMorphFor: self withSpec: aSpec! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForNextFocus

	^ ''! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 10:52'!
eventStringForPreviousFocus

	^ ''! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/17/2012 17:40'!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/7/2012 11:09'!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					^ next takeKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ self ].
			next takeKeyboardFocus ]
		ifNotNil: [ owner giveFocusToNextFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/23/2012 19:18'!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					^ previous takeLastKeyboardFocus ]].

	owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ ^ self ].
			next takeLastKeyboardFocus ]
		ifNotNil: [ owner giveFocusToPreviousFrom: self ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 01:31'!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/31/2012 13:15'!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ self class internSpec! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForNextFocus: aKeyboardEvent

	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 18:40'!
isEventForPreviousFocus: aKeyboardEvent 
	
	^ false! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 2/15/2012 17:18'!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: 'BenjaminVanRyseghem 2/18/2012 03:32'!
listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph

	morph ifNil: [ self buildWithSpec ].
	morph listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph	
	! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/21/2012 18:53'!
morph: anObject

	morph := anObject! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/28/2012 00:51'!
okToChange

	^ owner 
		ifNil: [
			self canDiscardEdits ifTrue: [^ true].
			self changed: #wantToChange.  "Solicit cancel from view"
			^ self canDiscardEdits]
		ifNotNil: [ owner okToChange ]! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:33'!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/1/2012 18:26'!
openWithSpec

	^ self openWithSpec: #internSpec.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/22/2012 00:04'!
openWithSpec: aSpec
	| window |

	window := StandardWindow new model: self.
	self addAll: window withSpec: aSpec.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/23/2012 19:27'!
owner: anObject
	
	owner ifNotNil: [owner removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	owner := anObject.! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/18/2012 02:10'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self morph ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 19:51'!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 12/21/2011 13:32'!
title

	^ self class title! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 2/23/2012 19:33'!
update: aParameter

	self changed: aParameter! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: 'BenjaminVanRyseghem 2/15/2012 18:21'!
widthToDisplayInList: aList
	
	morph ifNil: [ self buildWithSpec ].
	^ self morph widthToDisplayInList: aList! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DictionaryValueHolder commentStamp: '<historical>' prior: 0!
A DictionaryValueHolder is a value holder designed for Dictionaries!

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
at: key ifAbsentPut: aBlock 

	contents at: key ifAbsentPut: aBlock.
	self contentsChanged
	! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
at: key put: value

	contents at: key put: value.
	self contentsChanged
	! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/9/2012 16:56'!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:12'!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:31'!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/9/2012 16:26'!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 16:34'!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/9/2012 17:13'!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/28/2011 09:28'!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 09:31'!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:23'!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 09:35'!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:24'!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/16/2012 01:10'!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 2/9/2012 16:54'!
whenChangedDo: aBlock

	| block |
	block := [ aBlock cull: contents ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:09'!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/28/2011 17:27'!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/2/2012 13:58'!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec-Core' stamp: 'BenjaminVanRyseghem 11/28/2011 09:29'!
asValueHolder

	^ NewValueHolder contents: self! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

SpecInterpreter class
	instanceVariableNames: 'Bindings'!

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:33'!
bindings

	^ Bindings ifNil: [ self initializeBindings. ^ Bindings ]! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:39'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:40'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/30/2012 17:02'!
initialize

	super initialize.
	
	SystemBrowser registeredClasses do:[:each | each addGroupForPackage: self package ]! !

!SpecInterpreter class methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/19/2012 20:06'!
initializeBindings

	Bindings := Dictionary new.

	Bindings
		at: #List put: #PluggableListMorph;
		at: #IconList put: #PluggableIconListMorph;
		at: #Text put: #PluggableTextMorph;
		at: #Button put: #PluggableButtonMorph;
		at: #Panel put: #PanelMorph;
		at: #PanelWithSplitters put: #PanelMorphWithSplitters;
		at: #Checkbox put: #CheckboxMorph;
		at: #DropList put: #DropListMorph;
		at: #TextField put: #PluggableTextFieldMorph;
		at: #Label put: #LabelMorph;
		at: #MultiColumnList put: #PluggableMultiColumnListMorph! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/19/2012 16:36'!
interpretASpec: aSpec model: aModel
	
	^ self new	interpretASpec: aSpec model: aModel! !

!SpecInterpreter class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
resetBindings

	Bindings := nil! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
bindings
	
	^ bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: #internSpec! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 17:19'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 1/19/2012 16:38'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
classKeys

	^ Smalltalk keys, self bindings keys! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
convertSymbolOfClassToInstance: aSymbol

	| symbol |
	symbol := self bindings at: aSymbol ifAbsent: [ aSymbol ].

	^ (Smalltalk at: symbol) new! !

!SpecInterpreter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/4/2012 11:10'!
initialize
	"Initialization code for SpecInterpreter"

	super initialize.

	bindings := self class bindings.
	instance := nil.! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance

	^ instance! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/19/2012 16:25'!
instance: anObject
	
	instance := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 2/27/2012 06:34'!
interpretASpec: aSpec model: aModel
	| index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	(aSpec isString or: [ aSpec isText ]) ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self class interpretASpec: aSpec first model: aModel.
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self class interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					(aModel respondsTo: #morph:)
						ifTrue: [ aModel morph: instance ].
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: false.
	^ instance! !
SpecInterpreter initialize!
